/* Problem URL: https://codeforces.com/problemset/problem/1915/G */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;

        V<V<pair<int, ll>>> graph(n);

        while (m--) {
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;

            graph[a].emplace_back(b, c);
            graph[b].emplace_back(a, c);
        }

        vl fact(n);
        cin >> fact;

        auto dijkstra = [&]() {
            priority_queue<tuple<ll, int, int>, V<tuple<ll, int, int>>, greater<>> pq;
            ll inf = INT64_MAX >> 1;
            vvl dis(n, vl(n, inf));

            dis[0][0] = 0;
            pq.emplace(0, 0, 0);
            
            while (!pq.empty()) {
                auto [c, i, f] = pq.top();
                pq.pop();

                if (fact[i] < fact[f]) {
                    f = i;
                }

                if (c > dis[i][f]) {
                    continue;
                }

                for (auto [j, cc] : graph[i]) {
                    if (dis[j][f] > c + cc * fact[f]) {
                        dis[j][f] = c + cc * fact[f];
                        pq.emplace(c + cc * fact[f], j, f);
                    }
                }
            }

            return *min_element(all(dis[n - 1]));
        };

        cout << dijkstra() << '\n';
    }
}
